;ppmpx4a.asm version 3.5(for DPMI)
;	MACHINE LANGUAGE SUBROUTINES
;	FOR ppmpqs
;	1998-99 by YUJI KIDA
;
.386P

code	segment	use16
	assume	cs:code,ds:code

	INCLUDE	UBP.MAC
	include ppmpx.h

inactivesteplog	equ	8	;9
excesssafety	equ	8

change1024	macro
	mov	bx,ax
	shl	eax,6
	mov	ax,bx
	and	ax,1111111111b		;ax+1024*higherword=size
endm


	org	100h

start:
	jmp	start0

	include	dpmi4ub.h
	include	dpmi4ub.lib


start0:
	MOV_AX	AR0		;ARRAY[0] is the command
	MOV	BX,OFFSET CMD_TBL
	SHL	AX,1
	ADD	BX,AX
	JMP	CS:[BX]

CMD_TBL:
	dw	INITIALIZE,dummy,STORE_DATA,SETACTIVE
	dw	countcolumn,deleterow,GAUSS1,GAUSS2
	dw	CUTEXCESSROW,MAKERFB,freememory

	align	4
FBsize		dd	?
rowstotal	dd	?
rowsnow		dd	?
excessrows	dd	?

heavycolweight	dd	0	;higher word always 0

count0		dd	?
count1		dd	?

inactivenow	dd	?
inactivenext	dd	?
inactivecount	dd	?
inactiveinit1	dd	?

pointernow	dd	?
datanow		dd	?
columncount	dd	?

counterbase	dd	?
pointerbase	dd	?
datatop		dd	?
activeflgbase	dd	?

decompbuffersize	dd	?

decom2handle	dw	?
histhandle	dw	?

ptrbuffer2	dw	?
spmem		dw	?

didsomesw	dw	0




dummy:
	retf


;
; free DPMI memory
;
;command#=10

freememory:
	call	freemainDATAmemory
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


;
; make reduced FactorBase file
; and revived Row number file
;
;command#=9

RFBhandle	dw	0
RFBFILENAME	db	'ppmprfb.ppm',0
ROWShandle	dw	0
ROWSFILENAME	db	'ppmprows.ppm',0

makeRFB:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	mov	ah,3eh			;close history
	mov	bx,[histhandle]
	or	bx,bx
	jz	short makeRFB0
	int	21h
makeRFB0:
	mov	dx,offset RFBFILENAME
	mov	ah,3ch			;create handle
	mov	cx,0
	int	21h
	jc	makeRFBdiskerror
	mov	[RFBhandle],ax

	call	real2protB

	xor	edx,edx			;counter
	mov	ebx,[activeflgbase]
	mov	ecx,[FBsize]
makeRFB10:
	push	ebx
	push	ecx

	mov	eax,-1		;non use mark
	cmp	byte ptr fs:[ebx],1
	jne	short makeRFB20
	mov	eax,edx
	inc	edx
makeRFB20:
	push	edx
	mov	bx,offset BUFFER
	mov	[bx],eax

	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,4
	mov	bx,[RFBhandle]
	mov	ah,40h			;write
	int	21h
	jc	makeRFBdiskerror

	call	real2protB

	pop	edx
	pop	ecx
	pop	ebx

	inc	ebx
	dec	ecx
	jnz	makeRFB10

	push	edx
	call	prot2real
	pop	edx

	cmp	edx,[inactivenow]
	jne	makeRFBdataerror

	push	edx			;/*

	mov	ah,3eh			;close
	mov	bx,[RFBhandle]
	or	bx,bx
	jz	short makeROWS
	int	21h
	mov	[RFBhandle],0
makeROWS:
	mov	dx,offset ROWSFILENAME
	mov	ah,3ch			;create handle
	mov	cx,0
	int	21h
	jc	makeRFBdiskerror
	mov	[ROWShandle],ax

	call	real2protB

	xor	edx,edx			;counter
	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
makeROWS10:
	test	dword ptr fs:[ebx],deletedmark4B
	jnz	short makeROWS20

	push	ebx
	push	ecx
	push	edx

	mov	bx,offset BUFFER
	mov	eax,[FBsize]
	sub	eax,ecx
	mov	[bx],eax

	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,4
	mov	bx,[ROWShandle]
	mov	ah,40h			;write
	int	21h
	jc	makeRFBdiskerror

	call	real2protB

	pop	edx
	pop	ecx
	pop	ebx

	inc	edx

makeROWS20:
	add	ebx,4
	dec	ecx
	jnz	makeROWS10

	push	edx
	call	prot2real
	pop	edx

	pop	eax			;*/
	cmp	eax,edx
	jae	short makeROWS30
	mov	eax,edx
makeROWS30:
	add	eax,matrixunitsize-1
	and	eax,matrixunitmask	;reduced matrix size
	change1024

makeRFBret:
	mov	sp,[spmem]

	mov	bx,AR0
	mov	[bx],eax

	mov	ah,3eh			;close
	mov	bx,[RFBhandle]
	or	bx,bx
	jz	short makeRFBret2
	int	21h
makeRFBret2:
	mov	ah,3eh			;close
	mov	bx,[ROWShandle]
	or	bx,bx
	jz	short makeRFBskip
	int	21h

makeRFBskip:
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

makeRFBdiskerror:
	mov	ax,8001h
	jmp	makeRFBret

makeRFBdataerror:
	mov	ax,8002h
	jmp	makeRFBret

;
; cut excess rows
;
;command#=8

CUTEXCESSROW:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	mov	[excessrows],0
	mov	eax,[rowsnow]
	mov	edx,[FBsize]
	add	edx,[inactivenow]
	sub	edx,[count0]
	add	edx,excesssafety
	sub	eax,edx
	jbe	excessout		;no excess
	mov	[excessrows],eax

	call	real2protB

	mov	edi,[counterbase]	;counter area used for work buffer
	mov	ecx,[excessrows]        ;clear buffer
	shl	ecx,1			;8 bytes each
	xor	eax,eax
excess2:
	mov	fs:[edi],eax
	add	edi,4
	dec	ecx
	jnz	excess2
	dec	eax
	mov	fs:[edi],eax            ;sentinel

	mov	ecx,[FBsize]
	mov	ebx,[pointerbase]
	xor	edx,edx			;row#
excess10:
	push	ecx
	mov	esi,fs:[ebx]
	test	esi,deletedmark4B
	jnz	short excess20

	mov	eax,fs:[esi]		;weight
	mov	edi,[counterbase]
	cmp	eax,fs:[edi]
	jb	short excess20
	call	storethisrownumber
excess20:
	pop	ecx
	add	ebx,4
	inc	edx
	dec	ecx
	jnz	excess10

	;now delete highest weight rows

	mov	esi,[counterbase]
	mov	ecx,[excessrows]
	sub	esi,4
excess50:
	add	esi,8
	mov	eax,fs:[esi]
	shl	eax,2
	add	eax,[pointerbase]
	or	dword ptr fs:[eax],deletedmark4B
	dec	[rowsnow]
	dec	ecx
	jnz	excess50
	call	prot2real

excessout:
	mov	eax,[excessrows]
	change1024
	mov	bx,AR0
	mov	[bx],eax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

storethisrownumber:
	push	ebx
storethisrow10:
	mov	ebx,fs:[edi+8]
	mov	ecx,fs:[edi+12]
	cmp	eax,ebx
	jb	short storethisrow50
	mov	fs:[edi],ebx
	mov	fs:[edi+4],ecx
	add	edi,8
	jmp	storethisrow10
storethisrow50:
	mov	fs:[edi],eax		;weight
	mov	fs:[edi+4],edx		;row#
	pop	ebx
	ret


;
; GAUSSian elimination using the rows of weight 2
;
;command#=7

GAUSS2:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp
	mov	[didsomesw],0

	call	real2protB

	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
gauss210:
	push	ecx
	push	ebx
	mov	esi,fs:[ebx]
	test	esi,deletedmark4b
	jnz	short gauss220

	mov	eax,fs:[esi]		;weight
	cmp	eax,2
	jne	short gauss220

	or	dword ptr fs:[ebx],deletedmark4B
	dec	[rowsnow]

	call	setpivotnumber
	call	gauss2sub
	call	appendhistory
gauss220:
	pop	ebx
	pop	ecx
	add	ebx,4
	dec	ecx
	jnz	gauss210

	call	prot2real

	mov	ax,[didsomesw]
	mov	bx,AR0
	mov	[bx],ax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


gauss2sub:
	mov	edx,fs:[esi+4]		;dx = pivot smaller value
	mov	eax,fs:[esi+8]		;ax = pivot larger value

	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
gauss2submainlp:
	push	ecx			;*
	mov	esi,fs:[ebx]
	test	esi,deletedmark4b
	jnz	short gauss2sub20

	mov	cx,fs:[esi]
	jcxz	short gauss2sub20
gauss2sub12:
	add	esi,4
	cmp	eax,fs:[esi]
	jb	short gauss2sub20
	je	short gauss2sub30
	dec	cx
	jnz	gauss2sub12

gauss2sub20:
	pop	ecx			;*
	add	ebx,4
	dec	ecx
	jnz	gauss2submainlp
	ret

gauss2sub30:
	push	eax
	call	replacethis
	call	memooperation
	pop	eax
	jmp	gauss2sub20

replacethis:
	mov	edi,fs:[ebx]		;top adr
	mov	ecx,esi
	sub	ecx,edi
	shr	ecx,2
	dec	cx			;data# to be checked
	jz	short replacethisret
replacethislp:
	mov	eax,fs:[esi-4]
	cmp	eax,edx
	jb	short replacethisret
	je	short cutthis2
	mov	fs:[esi],eax
	sub	esi,4
	dec	cx
	jnz	replacethislp
replacethisret:
	mov	fs:[esi],edx
replacethisret2:
	ret

cutthis2:
	mov	eax,fs:[edi]		;weight
	mov	ecx,eax
	sub	eax,2
	mov	fs:[edi],eax
	jz	replacethisret2
	mov	eax,esi
	sub	eax,edi
	shr	eax,2
	sub	ecx,eax	
	jz	replacethisret2
cutthis2lp:
	add	esi,4
	mov	eax,fs:[esi]
	mov	fs:[esi-8],eax		;cut 2 members
	dec	ecx
	jnz	cutthis2lp
	jmp	replacethisret2

;
; GAUSSian elimination using the rows of weight 1
;
;command#=6

GAUSS1:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp
	mov	[didsomesw],0

	call	real2protB

gauss1mainlp:
	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
gauss110:
	push	ecx
	push	ebx

	mov	esi,fs:[ebx]
	test	esi,deletedmark4b
	jnz	short gauss120

	mov	eax,fs:[esi]		;weight
	dec	eax
	jnz	short gauss120		;if not 1 then skip
gaussweight1:
	or	dword ptr fs:[ebx],deletedmark4B
	dec	[rowsnow]
	call	setpivotnumber
	call	gauss1sub
	call	appendhistory
gauss120:
	pop	ebx
	pop	ecx
	add	ebx,4
	dec	ecx
	jnz	gauss110

	call	prot2real

	mov	ax,[didsomesw]
	mov	bx,AR0
	mov	[bx],ax
gauss1out:
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

appendhistory:
	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,[ptrbuffer2]
	sub	cx,dx
	jbe	short historyret
	mov	bx,[histhandle]

	mov	ah,40h			;write
	int	21h
	jc	gauss1diskerror
	mov	[didsomesw],1
historyret:
	call	real2protB
	ret

GAUSS1diskerror:
	mov	sp,[spmem]
	mov	bx,AR0
	mov	word ptr [bx],8001h
	jmp	gauss1out


setpivotnumber:
	mov	eax,ebx			;pivot element number
	sub	eax,[pointerbase]
	shr	eax,2
	mov	di,offset BUFFER0
	stosd
	mov	[ptrbuffer2],di
	ret


gauss1sub:
	mov	eax,fs:[esi+4]		;ax = pivot value
	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
gauss1submainlp:
	push	ecx			;*
	mov	esi,fs:[ebx]
	test	esi,deletedmark4b
	jnz	short gauss1sub20

	mov	cx,fs:[esi]
	jcxz	short gauss1sub20
gauss1sub12:
	add	esi,4
	cmp	eax,fs:[esi]
	jb	short gauss1sub20
	je	short gauss1sub30
	dec	cx
	jnz	gauss1sub12

gauss1sub20:
	pop	ecx			;*
	add	ebx,4
	dec	ecx
	jnz	gauss1submainlp
	ret

gauss1sub30:
	push	eax
	call	cutthis
	call	memooperation
	pop	eax
	jmp	gauss1sub20

cutthis:
	mov	edi,fs:[ebx]		;top adr
	mov	ecx,fs:[edi]
	dec	ecx
	mov	fs:[edi],ecx
	inc	ecx			;total data#
	mov	eax,esi
	sub	eax,edi
	shr	eax,2			;checked data#
	sub	ecx,eax			;remaining data#
	jbe	short cutthisret	;if last data
cutthislp:
	mov	eax,fs:[esi+4]		;cut 1 member
	mov	fs:[esi],eax
	add	esi,4
	dec	ecx
	jnz	cutthislp
cutthisret:
	ret

memooperation:
	mov	di,[ptrbuffer2]
	mov	eax,ebx
	sub	eax,[pointerbase]
	shr	eax,2
	stosd				;memo target
	mov	eax,[BUFFER0]
	stosd				;memo pivot
	mov	[ptrbuffer2],di
	cmp	di,offset BUFFERend
	jae	short memooperationwrite
	ret
memooperationwrite:
	call	appendhistory
	mov	di,offset BUFFER0+4
	mov	[ptrbuffer2],di
	ret


;
; delete row containing 1 data column
;
;command#=5

deleterow:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	mov	[count0],0
	mov	[count1],0

	call	real2protB

	mov	ecx,[FBsize]
	mov	ebx,[counterbase]
delrow10:
	cmp	dword ptr fs:[ebx],1
	ja	short delrow20
	je	short delrow15
	inc	[count0]
	jmp	short delrow20
delrow15:
	inc	[count1]
	mov	eax,fs:[ebx+4]
	shl	eax,2
	add	eax,[pointerbase]
	or	dword ptr fs:[eax],deletedmark4b
	dec	[rowsnow]
delrow20:
	add	ebx,8
	dec	ecx
	jnz	delrow10

	call	prot2real

	mov	eax,[count0]
	change1024
	mov	bx,AR0
	mov	[bx],eax
	mov	eax,[count1]
	change1024
	mov	bx,AR2
	mov	[bx],eax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


;
; count column weight
;
;command#=4

countcolumn:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	call	real2protB

	mov	edi,[counterbase]
	xor	eax,eax			
	mov	ecx,[FBsize]
countc10:				;clear counter
	mov	fs:[edi],eax
	add	edi,8
	dec	ecx
	jnz	countc10

	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
	xor	edx,edx			;row#
countc20:
	push	ecx			;/*

	mov	esi,fs:[ebx]
	test	esi,deletedmark4b
	jnz	short countc50

	mov	cx,fs:[esi]
	jcxz	short countc50
countc30:
	add	esi,4
	mov	eax,fs:[esi]
	shl	eax,3			;*8
	add	eax,[counterbase]
	inc	dword ptr fs:[eax]	;count
	mov	fs:[eax+4],edx		;row#
	dec	cx
	jnz	countc30
countc50:
	pop	ecx			;*/
	inc	edx
	add	ebx,4
	dec	ecx
	jnz	countc20

	call	prot2real

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

;
; set active/inactive
;
;command#=3

SETACTIVE:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	;count column weight

	call	real2protB

	mov	edi,[counterbase]
	xor	eax,eax			
	mov	ecx,[FBsize]
setact10:			;clear counter
	mov	fs:[edi],eax
	add	edi,8
	dec	ecx
	jnz	setact10

	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
setact20:
	push	ecx			;*
	mov	esi,fs:[ebx]
	test	esi,deletedmark4b
	jnz	short setact50
	mov	cx,fs:[esi]
	jcxz	short setact50
setact30:
	add	esi,4
	mov	eax,fs:[esi]
	shl	eax,3			;*8
	add	eax,[counterbase]
	inc	dword ptr fs:[eax]	;count
	dec	cx
	jnz	setact30
setact50:
	pop	ecx			;*
	add	ebx,4
	dec	ecx
	jnz	setact20

	;count rows for each weight
setact100:
	mov	di,offset BUFFER
	mov	cx,MaxColumnWeight
	xor	eax,eax
	rep	stosd

	xor	edx,edx			;maxweight
	mov	ebx,[counterbase]
	mov	ecx,[FBsize]
setact110:
	mov	eax,fs:[ebx]
	cmp	eax,MaxColumnWeight
	jb	short setact120
	mov	eax,MaxColumnWeight-1
setact120:
	cmp	eax,edx
	jbe	short setact130
	mov	edx,eax
setact130:
	shl	eax,2
	add	ax,offset BUFFER
	mov	si,ax
	inc	dword ptr [si]	;count this weight
	add	ebx,8
	dec	ecx
	jnz	setact110

	;decide heavy weight

	or	edx,edx
	jz	setactdone

	mov	ebx,edx
	mov	ecx,edx
	shl	ebx,2
	add	bx,offset BUFFER+4
	mov	eax,[inactivenow]
	push	eax			;/*
setact200:
	sub	bx,4
	add	eax,[bx]
	cmp	eax,[inactivenext]
	jae	short setact220
	dec	ecx
	jnz	setact200
	jmp	short setact225
setact220:
;//	mov	eax,[inactivenext]
setact225:
	mov	[inactivenow],eax
	mov	edx,eax
	mov	eax,[FBsize]
	sub	eax,edx
	shr	eax,inactivesteplog
	inc	eax			;avoid 0
	add	eax,edx
	cmp	eax,[FBsize]
	jbe	short setact230
	mov	eax,[FBsize]
setact230:
	mov	[inactivenext],eax

	mov	ax,bx
	sub	ax,offset BUFFER
	shr	ax,2			;define heavy weight >= ax
	mov	word ptr [heavycolweight],ax

	;make inactive

	pop	edx			;*/
	mov	eax,[inactivenow]
	sub	eax,edx
	jz	short setact330
	mov	[inactivecount],eax

	xor	edx,edx			;column#
	mov	ebx,[counterbase]
	dec	edx
	sub	ebx,8
setact310:
	inc	edx
	add	ebx,8
	mov	eax,fs:[ebx]
	cmp	eax,[heavycolweight]
	jb	setact310
	call	deleteEDX
	dec	[inactivecount]
	jnz	setact310

setact330:
	mov	ax,word ptr [heavycolweight]
setactret:
	push	ax
	call	prot2real
	pop	ax

	mov	bx,AR2
	mov	[bx],ax

	mov	eax,[inactivenow]
	change1024
	mov	bx,AR0
	mov	[bx],eax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

setactdone:
	xor	ax,ax
	jmp	setactret

deleteEDX:
	push	ebx
	mov	ebx,edx
	add	ebx,[activeflgbase]
;	cmp	byte ptr fs:[ebx],1
;	je	short deldxerr		;already inactive
	mov	byte ptr fs:[ebx],1

	mov	ebx,[pointerbase]
	mov	ecx,[FBsize]
deldx10:
	push	ecx
	mov	esi,fs:[ebx]
	test	esi,deletedmark4B
	jnz	short deldx40

	mov	cx,fs:[esi]
	or	cx,cx
	jz	short deldx40
deldx20:
	add	esi,4
	cmp	edx,fs:[esi]
	jb	short deldx40
	je	short deldx50
	dec	cx
	jnz	deldx20	
deldx40:
	pop	ecx
	add	ebx,4
	dec	ecx
	jnz	deldx10

deldxret:
	pop	ebx
	ret

deldx50:
	mov	edi,fs:[ebx]		;top adr
	dec	dword ptr fs:[edi]	;dec elements#
	dec	cx
	jz	deldx40			;if last element
deldx60:
	mov	eax,fs:[esi+4]		;slide down
	mov	fs:[esi],eax		;
	add	esi,4
	dec	cx
	jnz	deldx60
	jmp	deldx40

;
; set row data
; copy ppmpdcp2.ppm to higher address(from [datatop])

;COMMAND#=2

STORE_DATA:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	mov	[rowstotal],0

	mov	dx,offset decom2filename
	mov	ax,3d00h		;open for read
	int	21h
	jc	storediskerror
	mov	[decom2handle],ax

	call	storedatasub

	mov	eax,[rowstotal]
	mov	[rowsnow],eax
	cmp	eax,[FBsize]
	jne	decompdataerror

	mov	eax,[datanow]
	sub	eax,[datatop]
	shr	eax,10
	change1024
	mov	bx,AR0
	mov	[bx],eax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

decompdataerror:
	mov	ax,8002h	;-2 of UB
storeerror:
	mov	bx,AR0
	mov	[bx],ax

	mov	ah,3eh			;close
	mov	bx,[decom2handle]
	or	bx,bx
	jz	storeerrorjp
	int	21h
storeerrorjp:
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf
storediskerror:
	mov	ax,8001h	;-1 of UB
	jmp	storeerror

decommemerror:
	mov	ax,8003h
	jmp	storeerror


storedatasub:
	call	real2protB

	;read decomposition data and set in memory
storelp:
	call	prot2real

	mov	dx,offset BUFFER0	;read number of members
	mov	cx,4
	mov	bx,[decom2handle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	decomeof

	mov	bx,offset BUFFER0	;read all members
	lea	dx,[bx+4]
	mov	cx,[bx]			;use ony 2 byte
	shl	cx,2			;4bytes per unit
	mov	bx,[decom2handle]
	xor	eax,eax
	mov	ah,3fh
	int	21h

	call	real2protB

	mov	ebx,[pointernow]
	mov	edi,[datanow]
	mov	fs:[ebx],edi
	add	ebx,4
	mov	[pointernow],ebx

	; set to protect memory

	mov	si,offset BUFFER0
	lodsd
	mov	fs:[edi],eax
	add	edi,4
	mov	cx,ax
	or	ax,ax
	jz	short setdataend	;if no data

setdatalp:				;cut small primes
	lodsd
	cmp	eax,[inactiveinit1]
	jb	short setdatajp		;not store
setdatado:
	mov	fs:[edi],eax
	add	edi,4
setdatajp:
	dec	cx
	jnz	setdatalp

setdataend:
	mov	ebx,[datanow]
	mov	[datanow],edi
	sub	edi,ebx
	shr	edi,2
	dec	edi
	mov	fs:[ebx],edi		;# of elements
	mov	eax,[rowstotal]
	inc	eax
	mov	[rowstotal],eax
	cmp	eax,[FBsize]
	jb	storelp
	call	prot2real

decomeof:
	mov	ah,3eh			;close
	mov	bx,[decom2handle]
	int	21h
	ret


decom2filename	db	'ppmpdcp2.ppm',0


;
;* Initialize
;COMMAND#=0

;	AR[1,2]	total data
;	AR[3,4]	rationa and character data
;	AR[5]	total data/inactive data

INITIALIZE:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	xor	eax,eax
	MOV_AX	AR1
	shl	eax,10
	mov	edx,eax
	xor	eax,eax
	MOV_AX	AR2
	add	eax,edx
	mov	[FBsize],eax
	push	eax

	xor	eax,eax
	MOV_AX	AR3
	mov	ebx,eax
	pop	eax
	xor	edx,edx
	div	ebx
	mov	[inactivenow],eax

	shl	eax,1
	sub	eax,16
	mov	[inactivenext],eax

	xor	edx,edx
	mov	eax,[FBsize]
	div	ebx
	mov	[inactiveinit1],eax

	;DPMI initialize

	mov	ebx,[FBsize]
	mov	ecx,ebx
	shl	ebx,2
	xor	eax,eax
	mov	[activeflgbase],eax
	add	eax,ecx		;active flg uses 1 byte
	mov	[counterbase],eax
	add	eax,ebx
	add	eax,ebx		;counter uses 8 byte
	mov	[pointerbase],eax
	mov	[pointernow],eax
	add	eax,ebx		;pointer uses 4 byte
	mov	[datatop],eax
	mov	[datanow],eax

	;needs memories after [datatop]
	;   reduced image of ppmpdcp2.ppm

	call	getdcmp2size
	add	eax,8			;for safety
	add	eax,[datatop]
	add	eax,15			;for alignment safety
	mov	[DPMImemorysize],eax

	call	DPMIinit
	jc	DPMIerror

	mov	eax,dword ptr [DPMIaddresslow]
	add	eax,0fh
	and	ax,0fff0h
	add	[activeflgbase],eax
	add	[counterbase],eax
	add	[pointerbase],eax
	add	[pointernow],eax
	add	[datatop],eax
	add	[datanow],eax

	mov	esi,[activeflgbase]	;set active/inactive
	mov	al,1
	mov	ecx,[inactiveinit1]
init80:
	mov	fs:[esi],al
	inc	esi
	dec	ecx
	jnz	init80

	xor	al,al
	mov	ecx,[FBsize]
	sub	ecx,[inactiveinit1]
init90:
	mov	fs:[esi],al
	inc	esi
	dec	ecx
	jnz	init90

	call	prot2real

	mov	dx,offset historyfilename
	mov	ah,3ch			;create handle
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[histhandle],ax

	mov	ax,word ptr [DPMImemorysize+2]
	mov	bx,AR1
	mov	[bx],ax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

diskerror:
	mov	bx,AR0
	mov	word ptr [bx],8001h	;-1 of UB

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

dpmierror:
;	call	prot2real
	mov	bx,AR1
	mov	word ptr [bx],8001h	;-1 of UB
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


historyfilename	db	'ppmphist.ppm',0

; count active data size of ppmpdcp2.ppm

getdcmp2size:
	mov	dx,offset decom2filename
	mov	ax,3d00h		;open for read
	int	21h
	mov	[decom2handle],ax
	call	getdcmp2sizesub
	ret

getdcmp2sizesub:
	xor	edi,edi			;counter of active data
getdcmp210:
	mov	dx,offset BUFFER0	;read number of members
	mov	cx,4
	mov	bx,[decom2handle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	short getdcmp2eof

	add	edi,4			;for attribute area

	mov	bx,offset BUFFER0	;read all members
	lea	dx,[bx+4]
	mov	cx,[bx]			;use only 2 byte
	or	cx,cx
	jz	short getdcmp250
	push	cx			;/*
	shl	cx,2			;4bytes per unit
	mov	bx,[decom2handle]
	xor	eax,eax
	mov	ah,3fh
	int	21h

	mov	si,offset BUFFER
	pop	cx			;*/
getdcmp230:
	mov	eax,[si]
	add	si,4

	cmp	eax,[inactiveinit1]
	jb	short getdcmp240		;not store
	add	edi,4			;count this
getdcmp240:
	dec	cx
	jnz	getdcmp230
getdcmp250:
	jmp	getdcmp210

getdcmp2eof:
	mov	ah,3eh			;close
	mov	bx,[decom2handle]
	int	21h

	mov	eax,edi
	ret


	align	4
BUFFER0	dd	?
BUFFER	dd	MaxColumnweight dup(0)
	dd	1e00h dup(0)
BUFFERend	dd	0

CODE	ENDS
END	START
