;ppmpx5a.asm version 3.5(for DPMI)
;	MACHINE LANGUAGE SUBROUTINES
;	FOR ppmpqs
;	1998-99 by YUJI KIDA
;
.386p


code	segment	use16
	assume	cs:code,ds:code

	INCLUDE	UBP.MAC
	include	ppmpx.h

bufferWsize	equ	7800h

change1024	macro
	mov	bx,ax
	shl	eax,6
	mov	ax,bx
	and	ax,1111111111b	;ax+higherword*1024=correct value
endm


	org	100h
start:
	JMP	start0

	include	dpmi4ub.h
	include	dpmi4ub.lib


	align	4
localbase	dd	?
localnow	dd	?
workbase	dd	?
maskbase	dd	?
xferbase	dd	?

MATsize		dd	?
MATsize1	dd	?
MATsize2	dd	?
MATsize3	dd	?

MATbytes	dw	0,0
MATbytes4	dw	0,0
MATwords	dw	0,0
MATdwords	dw	0,0

unitrows	dd	0
startrow	dd	?
checkingrow	dd	?
localrank	dd	?

MAToffset	dd	?
anshandle	dw	?
MAThandle	dw	?
MAThandle1	dw	?
MAThandle2	dw	?
MAThandle3	dw	?
MAThandle4	dw	?

RWrow		dd	?

answers		dd	?

spmem		dw	?


;branch

START0:
	MOV_AX	AR0		;ARRAY[0] is the command number
	MOV	BX,OFFSET CMD_TBL
	SHL	AX,1
	ADD	BX,AX
	JMP	CS:[BX]

CMD_TBL:
	DW	gauss_INIT,GAUSS,closefiles

;
; * Close Files and Free DPMI memory
;
;command#=2

closefiles:
	mov	ax,cs
	mov	ds,ax

	mov	ah,3eh
	mov	bx,[MAThandle1]
	int	21h

	mov	ah,3eh
	mov	bx,[MAThandle2]
	int	21h

	mov	ah,3eh
	mov	bx,[MAThandle3]
	int	21h

	mov	ah,3eh
	mov	bx,[MAThandle4]
	int	21h

	mov	ah,3eh
	mov	bx,[anshandle]
	int	21h

	mov	eax,[answers]
	change1024
	mov	bx,AR0
	mov	[bx],eax

	call	freemainDATAmemory
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


;
;** Gaussin elimination
;
;command#=1

Gauss:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	call	real2protB

	mov	eax,[startrow]
	mov	[checkingrow],eax
	call	getpivotrows
	or	eax,eax
	jz	short gauss100

	mov	[localrank],eax
	mov	edx,[checkingrow]
	mov	[startrow],edx

	call	erase_below
gauss100:
	mov	eax,[startrow]
	cmp	eax,[MATsize]
	jb	short gaussret
	mov	bx,AR0
	mov	word ptr [bx],0
gaussret:
	call	prot2real

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


getpivotrows:
	mov	eax,[localbase]
	mov	[localnow],eax
	mov	ecx,[unitrows]
	mov	eax,[checkingrow]
getpivot10:
	cmp	eax,[MATsize]
	jae	getpivot50	;data ended without filling all

	push	ecx
	mov	[RWrow],eax
	xor	ebx,ebx
	mov	dx,[MAThandle1]
	cmp	eax,[MATsize1]
	jb	short getpivot12
	mov	ebx,[MATsize1]
	mov	dx,[MAThandle2]
	cmp	eax,[MATsize2]
	jb	short getpivot12
	mov	ebx,[MATsize2]
	mov	dx,[MAThandle3]
	cmp	eax,[MATsize3]
	jb	short getpivot12
	mov	ebx,[MATsize3]
	mov	dx,[MAThandle4]
getpivot12:
	mov	[MAThandle],dx
	mov	[MAToffset],ebx

	call	load_row

	call	isbuffer0
	jz	short getpivot20	;erased data

	call	erasebyothers
	jc	short getpivot20	;there is a vanished data

	;MSW data(ax,cx,ebx) is updated by erasebyothers

	mov	edx,[checkingrow]	;set xfer data(Toma)
	shl	ebx,2			;
	add	ebx,[xferbase]		;
	mov	fs:[ebx],edx		;

	not	ax			;clear the bit(Toma)
	add	di,cx			;
	xor	ebx,ebx			;
	and	[di],ax			;
	mov	bx,cx			;
	add	ebx,[maskbase]		;
	and	fs:[ebx],ax		;

	call	copy2local
	mov	eax,[checkingrow]
	inc	eax
	mov	[checkingrow],eax
	pop	ecx
	dec	ecx
	jnz	getpivot10

getpivot50:
	mov	eax,[unitrows]
	sub	eax,ecx		;eax = rank increased now
	ret

getpivot20:
	pop	ecx
	mov	eax,[checkingrow]
	inc	eax
	mov	[checkingrow],eax
	jmp	getpivot10	;non dec ecx


erasebyothers:
	mov	esi,[localbase]
	cmp	esi,[localnow]
	je	short erase30		;no former
erase10:
	mov	bx,fs:[esi]		;word offset of MSW
	mov	ax,fs:[esi+2]		;bit pattern of word
	mov	di,offset BUFFER
	test	ax,[bx+di]
	jz	short erase20
	add	esi,4

	mov	cx,[MATdwords]		;=dword row length
eraselp:
	mov	eax,fs:[esi]
	add	esi,4
	xor	[di],eax
	add	di,4
	dec	cx
	jnz	eraselp
	jmp	short erase25
erase20:
	add	esi,dword ptr [MATbytes4]
erase25:
	cmp	esi,[localnow]
	jb	erase10		
erase30:
	mov	di,offset BUFFER
	call	calcMSW
	mov	[di-4],cx
	mov	[di-2],ax
	or	ax,ax
	jz	erasegetans1	;find an answer
	clc
eraseret:
	ret

erasegetans1:			;if the new member
				;becomes an answer
	call	xferbufferdata

	call	prot2real

	mov	ah,40h		;write
	mov	bx,[anshandle]
	mov	cx,[MATbytes]
	mov	dx,offset BUFFER
	int	21h
	jc	ansdiskerror

	call	real2protB

	inc	[answers]
	stc
	jmp	eraseret


ansdiskerror:
	mov	sp,[spmem]
	mov	bx,AR0
	mov	word ptr [bx],8001h
	jmp	gaussret


xferbufferdata:
	;(1) make xfered data in workbase

	mov	edi,[workbase]
	mov	cx,[MATdwords]
	xor	eax,eax
xferbuf10:			;clear work
	mov	fs:[edi],eax
	add	edi,4
	dec	cx
	jnz	xferbuf10

	mov	cx,[MATdwords]
	mov	si,offset BUFFER
	mov	edi,[xferbase]
xferbuflp:
	push	cx
	mov	eax,[si]
	add	si,4
	mov	ch,32
xferbuflp2:
	shr	eax,1
	jnc	short xferbufjp
	mov	ebx,fs:[edi]
	mov	cl,bl
	shr	ebx,4
	and	cl,1111b	;get lower 4bits
	shl	ebx,1
	mov	dx,1
	add	ebx,[workbase]
	shl	dx,cl
	or	fs:[ebx],dx	;set corresponding bit
xferbufjp:
	add	edi,4
	dec	ch
	jnz	xferbuflp2

	pop	cx
	dec	cx
	jnz	xferbuflp

	;(2) copy to buffer

	mov	esi,[workbase]
	mov	di,offset BUFFER
	mov	cx,[MATdwords]
xferbuf100:
	mov	eax,fs:[esi]
	add	esi,4
	mov	[di],eax
	add	di,4
	dec	cx
	jnz	xferbuf100

	;(3) set the own bit

	mov	ebx,[checkingrow]
	mov	cl,bl
	shr	ebx,4
	and	cl,1111b	;get lower 4bits
	shl	bx,1
	mov	dx,1
	add	bx,offset BUFFER
	shl	dx,cl
	or	[bx],dx		;set corresponding bit

	ret


copy2local:
	mov	si,offset MSWoffset
	mov	edi,[localnow]
	mov	cx,[MATdwords]
	inc	cx
copylp:
	mov	eax,[si]
	add	si,4
	mov	fs:[edi],eax
	add	edi,4
	dec	cx
	jnz	copylp
	mov	[localnow],edi
	ret


erase_below:
	mov	eax,[checkingrow]
	mov	ecx,[MATsize]
	mov	[RWrow],eax
	sub	ecx,eax
	jz	erasebelowret

	xor	ebx,ebx
	mov	dx,[MAThandle1]
	cmp	eax,[MATsize1]
	jb	short eraseb1
	mov	ebx,[MATsize1]
	mov	dx,[MAThandle2]
	cmp	eax,[MATsize2]
	jb	short eraseb1
	mov	ebx,[MATsize2]
	mov	dx,[MAThandle3]
	cmp	eax,[MATsize3]
	jb	short eraseb1
	mov	ebx,[MATsize3]
	mov	dx,[MAThandle4]
eraseb1:
	mov	[MAThandle],dx
	mov	[MAToffset],ebx

erasebelowloop:
	push	ecx		;/*

	call	load_row
	call	make_xor
	call	save_row

	pop	ecx		;*/
	mov	eax,[RWrow]
	inc	eax
	mov	[RWrow],eax
	xor	ebx,ebx
	mov	dx,[MAThandle1]
	cmp	eax,[MATsize1]
	jb	short eraseb2
	mov	ebx,[MATsize1]
	mov	dx,[MAThandle2]
	cmp	eax,[MATsize2]
	jb	short eraseb2
	mov	ebx,[MATsize2]
	mov	dx,[MAThandle3]
	cmp	eax,[MATsize3]
	jb	short eraseb2
	mov	ebx,[MATsize3]
	mov	dx,[MAThandle4]
eraseb2:
	mov	[MAThandle],dx
	mov	[MAToffset],ebx
	dec	ecx
	jnz	erasebelowloop
erasebelowret:
	ret


make_xor:
	mov	esi,[localbase]
	mov	ecx,[localrank]
makexor10:
	push	ecx		;/*
	mov	di,word ptr fs:[esi]	;MSW word adr
	mov	ax,fs:[esi+2]		;mask
	add	di,offset BUFFER
	test	[di],ax
	jz	short makexornext

	add	esi,4
	mov	di,offset BUFFER
	mov	cx,[MATdwords]
makexorlp:
	mov	eax,fs:[esi]
	add	esi,4
	xor	[di],eax
	add	di,4
	dec	cx
	jnz	makexorlp
	jmps	makexor70
makexornext:
	add	esi,dword ptr [MATbytes4]
makexor70:
	pop	ecx		;*/
	dec	ecx
	jnz	makexor10
	ret


load_row:
	mov	eax,[RWrow]
	sub	eax,[MAToffset]
	mul	dword ptr [MATbytes]
	push	eax		;/*

	call	prot2real

	pop	dx		;*/
	pop	cx		;cx:dx = file ptr

	mov	ah,42h		;move file ptr
	mov	al,0		;absolute
	mov	bx,[MAThandle]
	int	21h

	mov	ah,3fh		;read
	mov	bx,[MAThandle]
	mov	cx,[MATbytes]
	mov	dx,offset BUFFER
	int	21h

	call	real2protB
	ret


save_row:
	mov	eax,[RWrow]
	sub	eax,[MAToffset]
	mul	dword ptr [MATbytes]

	push	eax

	call	prot2real

	pop	dx
	pop	cx		;cx:dx = file ptr

	mov	ah,42h		;move file ptr
	mov	al,0		;absolute
	mov	bx,[MAThandle]
	int	21h

	mov	ah,40h		;write
	mov	bx,[MAThandle]
	mov	cx,[MATbytes]
	mov	dx,offset BUFFER
	int	21h

	call	real2protB
	ret


isbuffer0:
	;out ZF = 1 iff buffer = 0

	mov	di,offset BUFFER
	mov	cx,[MATdwords]
	xor	eax,eax
is0lp:
	cmp	eax,[di]
	jne	short is0ret
	add	di,4
	dec	cx
	jnz	is0lp
is0ret:
	ret


calcMSW:
	;in: di = base adr = offset BUFFER
	;out: ax = mask of MSB of MSW, cx = offset adr of MSW
	;    ebx = absolute bit position

	push	di
	mov	esi,[maskbase]
	mov	eax,dword ptr [MATbytes]
	add	di,ax
	add	esi,eax
	mov	cx,[MATdwords]
calcMSW10:
	sub	di,4
	sub	esi,4
	mov	eax,fs:[esi]
	and	eax,[di]	;and with mask
	jnz	short calcMSW30
	dec	cx
	jnz	calcMSW10
calcMSWzero:			;if 0 then return with eax=0
	pop	di
	ret

calcMSW30:
	bsr	ecx,eax
	cmp	cx,16
	jb	short calcMSW40	;higher is 0
	sub	cx,16
	add	di,2
calcMSW40:
	mov	ax,1
	shl	ax,cl
	mov	ebx,ecx
	mov	cx,di
	pop	di
	sub	cx,di
	shl	ecx,3		;*8
	add	ebx,ecx
	shr	ecx,3
	ret

;
;* Initialize for Gaussian elimination
;
;command#=0

gauss_init:
	;get parameters

	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	xor	eax,eax
	mov_ax	AR2
	shl	eax,5		;* 32
	mov	[MATsize],eax	;reduced matrix size
	shr	eax,3		;* 1 / 8
	mov	[MATbytes],ax	;16bit from here
	add	ax,4
	mov	[MATbytes4],ax
	sub	ax,4
	shr	ax,1
	mov	[MATwords],ax

	cmp	ax,bufferWsize
	jae	gausstoolarge	;error

	shr	ax,1
	mov	[MATdwords],ax

	mov	[startrow],0
	mov	[answers],0

	;get DPMI memory

	xor	eax,eax
	mov_AX	AR1
	or	ax,ax
	jnz	short dpmisetjp1
	mov	ax,1		;min 1M
dpmisetjp1:
	shl	eax,20
dpmisetin:
	mov	[DPMImemorysize],eax
	mov	eax,[MATsize]
	cmp	eax,65536
	jae	short dpmisetgo
	add	eax,35			;for non matrix area
	mul	dword ptr [MATbytes4]
	cmp	eax,[DPMImemorysize]
	jae	short dpmisetgo
	mov	[DPMImemorysize],eax
dpmisetgo:
	call	DPMIinit
	jc	dpmierror

	call	prot2real

	mov	eax,dword ptr [DPMIaddresslow]
	add	eax,0fh
	and	al,0f0h
	mov	edx,dword ptr [MATbytes]
	mov	[workbase],eax
	add	eax,edx
	mov	[maskbase],eax
	add	eax,edx
	mov	[xferbase],eax
	shl	edx,5		;*8 *4
	add	eax,edx
	mov	[localbase],eax

	mov	eax,[DPMImemorysize]
	sub	eax,[localbase]
	add	eax,dword ptr [DPMIaddresslow]
	xor	edx,edx
	mov	ecx,dword ptr [MATbytes4]
	div	ecx		;eax = max number of rows
	mov	ecx,[MATsize]
	cmp	eax,ecx
	jbe	short checkmemory140
	mov	eax,ecx		
checkmemory140:
	mov	[unitrows],eax

	call	real2protB
	call	initmask
	call	initxfer
	call	prot2real
	call	openMATRIXfiles
	call	createANSfile

	mov	eax,[MATsize]
	shr	eax,2		;1/4
	shr	eax,ROWSblocklog
	shl	eax,ROWSblocklog
	mov	edx,eax
	mov	[MATsize1],eax
	add	eax,edx
	mov	[MATsize2],eax
	add	eax,edx
	mov	[MATsize3],eax

	mov	eax,[unitrows]
	change1024
gauss_init_out:
	mov	bx,AR0
	mov	[bx],eax

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

diskerror:
	mov	ax,8001h	;set -1
gausserrout:
	mov	sp,[spmem]
	jmp	gauss_init_out

dpmierror:
	mov	ax,8002h	;set -2
	jmp	gausserrout

gausstoolarge:
	mov	ax,8003h	;set -3
	jmp	gausserrout


initmask:
	mov	esi,[maskbase]
	mov	ecx,dword ptr [MATbytes]
	shr	ecx,2		;dword size
	xor	eax,eax
	dec	eax
initmasklp:
	mov	fs:[esi],eax	;set all bits
	add	esi,4
	dec	ecx
	jnz	initmasklp
	ret

initxfer:
	mov	esi,[xferbase]
	mov	ecx,[MATsize]
	xor	eax,eax
	dec	eax
initxferlp:
	mov	fs:[esi],eax
	add	esi,4
	dec	ecx
	jnz	initxferlp
	ret


createansfile:		;in real mode
	mov	ah,3ch		;create handle
	mov	dx,offset ANSFILENAME
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[anshandle],ax

	mov	ah,40h		;write matrixsize
	mov	bx,[anshandle]
	mov	cx,4
	mov	dx,offset MATsize
	int	21h
	jc	diskerror
	ret


openMATRIXfiles:	;in real mode
	mov	dx,offset MATRIXNAME1
	mov	ah,3dh
	mov	al,2		;read/write
	int	21h
	jc	diskerror
	mov	[MAThandle1],ax

	mov	dx,offset MATRIXNAME2
	mov	ah,3dh
	mov	al,2		;read/write
	int	21h
	jc	diskerror
	mov	[MAThandle2],ax

	mov	dx,offset MATRIXNAME3
	mov	ah,3dh
	mov	al,2		;read/write
	int	21h
	jc	diskerror
	mov	[MAThandle3],ax

	mov	dx,offset MATRIXNAME4
	mov	ah,3dh
	mov	al,2		;read/write
	int	21h
	jc	diskerror
	mov	[MAThandle4],ax
	ret


ANSFILENAME	db	'ppmpans.ppm',0
MATRIXNAME1	db	'ppmpmat1.ppm',0
MATRIXNAME2	db	'ppmpmat2.ppm',0
MATRIXNAME3	db	'ppmpmat3.ppm',0
MATRIXNAME4	db	'ppmpmat4.ppm',0

	align 4
MSWoffset	dw	?
MSWmask		dw	?
BUFFER		dw	bufferWsize dup(0)


CODE	ENDS
END	START
