;PPMPX6.ASM version 3.5(for DPMI)
;	MACHINE LANGUAGE SUBROUTINES
;	FOR PPMPQS
;	1991-99 by YUJI KIDA
;
.386p

code	segment	use16
	assume	cs:code,ds:code


	INCLUDE	UBP.MAC
	include	ppmpx.h

	org	100h
start:
	JMP	start0

	include	dpmi4ub.h
	include	dpmi4ub.lib


  align	4
primebase		dd	?

P_OFF		dd	?
E_OFF		dd	?

Y_OFF		dw	?
Y_SEG		dw	?

primes		dd	?
FBsize		dd	?

primehandle	dw	?
decomphandle	dw	?
anshandle	dw	?

ans_seg		dw	?
decompbuffer	dw	?
lastdecomp	dd	?

Tbytes		dw	?
Twords		dw	?
Tdwords		dw	?

spmem		dw	?


;branch

START0:
	MOV_AX	AR0		;ARRAY[0] is the command number
	MOV	BX,OFFSET CMD_TBL
	SHL	AX,1
	ADD	BX,AX
	JMP	CS:[BX]

CMD_TBL:
	DW	final_init,square_ans,putPandE,closefiles

;
; close files and free DPMI memory
;
;command#=3

closefiles:
	mov	ah,3eh
	mov	bx,cs:[anshandle]
	or	bx,bx
	jz	short closefnext
	int	21h
closefnext:
	call	freemainDATAmemory
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

;
; answer exponents of p
;
;command#=2

putPandE:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	call	real2protB

	mov	ebx,[primebase]
	add	ebx,12			;exp part of 2
	mov	ecx,[primes]
putPE10:
	mov	eax,fs:[ebx]
	or	eax,eax
	jnz	short putPE100
	add	ebx,8
	dec	ecx
	jnz	putPE10

	mov	esi,[P_OFF]
	mov	word ptr fs:[esi],0		;set 0 = no more data

putPEret:
	call	prot2real
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

putPE100:
	mov	dword ptr fs:[ebx],0	;clear
	mov	esi,[E_OFF]
	call	seteax
	mov	eax,fs:[ebx-4]
	mov	esi,[P_OFF]
	call	seteax
	jmp	putPEret

seteax:
	mov	cx,2
	cmp	eax,10000h
	jae	short seteaxjp
	dec	cx
	or	ax,ax
	jnz	short seteaxjp
	dec	cx
seteaxjp:
	mov	fs:[esi],cx
	mov	fs:[esi+2],eax
	ret


;
; answer square data
;
;command#=1

square_ans:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	mov	dx,offset BUFFER	;read answer
	mov	cx,[Tbytes]
	mov	bx,[anshandle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	nomoreanswer

	mov	si,offset BUFFER
	mov	es,[ans_seg]
	xor	di,di
	mov	cx,[Twords]
	mov	ax,cx
	stosw			;word length
	rep	movsw

	call	opendecomp
	call	real2protB
	call	countexponents
	call	prot2real
	call	closedecomp
squareret:
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

nomoreanswer:
	mov	bx,AR0
	mov	word ptr [bx],0
	jmp	squareret


countexponents:
	mov	edi,[primebase]
	add	edi,4			;adr of exponents
	mov	ecx,[FBsize]
	xor	eax,eax
ctexp10:
	mov	fs:[edi],eax		;clear exponents
	add	edi,8
	dec	ecx
	jnz	ctexp10

	xor	ebx,ebx
	mov	si,offset BUFFER
	mov	cx,[Twords]
ctexp20:
	push	cx
	lodsw
	mov	cx,16
ctexp30:
	shr	ax,1
	jc	short ctexp100
ctexp40:
	inc	ebx
	loop	ctexp30

	pop	cx
	dec	cx
	jnz	ctexp20
	ret

ctexp100:
	push	ax
	push	cx
	push	ebx
	push	esi

	push	ebx
	call	prot2real
	pop	ebx
	call	getdecompEBX
	call	real2protB
	mov	di,[decompbuffer]
	mov	cx,[di]
  align	4
ctexp110:
	add	edi,4
	mov	eax,[di]
	shl	eax,3			;*8
	add	eax,[primebase]
	add	eax,4
	inc	dword ptr fs:[eax]	;inc exponents
	loop	ctexp110

	pop	esi
	pop	ebx
	pop	cx
	pop	ax
	jmp	ctexp40

opendecomp:
	mov	dx,offset decompfilename
	mov	ax,3d00h		;open for read
	int	21h
	jc	diskerror
	mov	[decomphandle],ax
	mov	[lastdecomp],0
	ret


getdecompEBX:
	sub	ebx,[lastdecomp]
	jz	short getdecompfind
	add	[lastdecomp],ebx
getdecomp10:
	push	ebx
	mov	dx,[decompbuffer]
	mov	cx,4
	mov	bx,[decomphandle]
	mov	ah,3fh			;read header
	int	21h

	mov	bx,[decompbuffer]
	xor	cx,cx
	mov	dx,[bx]
	mov	bx,[decomphandle]
	shl	dx,2			;4bytes each
	mov	ax,4201h		;move file ptr relative
	int	21h

	pop	ebx
	dec	ebx
	jnz	getdecomp10
getdecompfind:
	mov	dx,[decompbuffer]
	mov	cx,4
	mov	bx,[decomphandle]
	mov	ah,3fh			;read header
	int	21h

	mov	bx,[decompbuffer]
	mov	dx,bx
	mov	cx,[bx]
	add	dx,4
	mov	bx,[decomphandle]
	shl	cx,2			;4bytes each
	mov	ah,3fh			;read data
	int	21h

	inc	[lastdecomp]		;count this read
	ret

closedecomp:
	mov	ah,3eh			;close file
	mov	bx,[decomphandle]
	int	21h
	ret


;
;* Initialize
;
;COMMAND#=0
;

seg2linear:
	movzx	eax,word ptr [bx+2]
	movzx	edx,word ptr [bx]
	shl	eax,4
	add	eax,edx
	ret


final_init:
	;get parameters

	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	MOV_AX	V1+2		;memo the segment of ans%(0)
	ADD	AX,ARRAYHEADSEG
	MOV	[ANS_SEG],AX

	MOV	BX,V2		;memo the address of P
	call	seg2linear
	mov	[P_OFF],eax

	MOV	BX,V3		;memo the address of E
	call	seg2linear
	mov	[E_OFF],eax

	MOV	BX,V4		;memo the address of Y
	MOV	AX,[BX]
	MOV	[Y_OFF],AX
	MOV	AX,[BX+2]
	MOV	[Y_SEG],AX

	xor	eax,eax
	mov_ax	AR2
	shl	eax,5			;*32
	mov	[FBsize],eax
	dec	eax
	mov	[primes],eax
	inc	eax
	shr	eax,3			;/ 8
	mov	[Tbytes],ax		;this restrics FBsize < 8*2^16
	shr	ax,1
	mov	[Twords],ax
	shr	ax,1
	mov	[Tdwords],ax

	mov	si,offset BUFFER
	mov	cx,[Tbytes]
	add	si,cx
	mov	[decompbuffer],si

	;get DPMI memory

	call	getdecompptrsize
	push	eax
	call	getprimeworksize
	pop	edx
	add	eax,edx
	add	eax,0fh		;for alignment safety *
	mov	[DPMImemorysize],eax

	call	DPMIinit
	jc	short dpmierror

	mov	eax,dword ptr [DPMIaddresslow]
	add	eax,0fh		;
	and	al,0f0h		;*
	mov	[primebase],eax

	call	prot2real
	call	openANSFILE
	call	getPRIMES

initout:
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

diskerror:
	mov	ax,8001h
initerror:
	mov	ds:[AR0],ax
	mov	sp,[spmem]
	jmp	initout

dpmierror:
;	call	prot2real
	mov	ax,8002h
	jmp	initerror


openANSFILE:
	mov	dx,offset ansfilename
	mov	ax,3d00h
	int	21h
	jc	diskerror
	mov	[anshandle],ax
	ret


getPRIMES:
	mov	dx,offset primefilename
	mov	ax,3d00h		;open for read
	int	21h
	jc	diskerror
	mov	[primehandle],ax

	mov	edi,[primebase]
primelp:
	mov	dx,offset BUFFER
	mov	cx,1000h
	mov	bx,[primehandle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	short primeeof

	push	ax
	push	edi
	call	real2protB
	pop	edi
	pop	cx

	shr	cx,2
	mov	si,offset BUFFER
prime50:
	lodsd
	mov	fs:[edi],eax
	add	edi,8		;additional dword is used for exponent
	loop	prime50

	push	edi
	call	prot2real
	pop	edi
	jmp	primelp

primeeof:
	mov	ah,3eh
	mov	bx,[primehandle]
	int	21h
	ret


getdecompptrsize:
	mov	dx,offset DECOMPFILENAME
	mov	ax,3d00h		;read open
	int	21h

	mov	bx,ax
	xor	esi,esi
getdecompptrsize10:
	mov	ah,3fh		;read file
	mov	cx,4
	mov	dx,offset BUFFER
	int	21h
	or	ax,ax
	jz	getdecompptrsize20	;eof

	mov	edx,dword ptr [BUFFER]	;# of members
	shl	edx,2		;*4
	add	esi,4

	push	edx
	pop	dx
	pop	cx
	mov	ax,4201h		;move file ptr
	int	21h
	jmp	getdecompptrsize10

getdecompptrsize20:
	mov	ah,3eh			;close file
	int	21h
	mov	eax,esi			;eax = result
	ret


getprimeworksize:
	mov	dx,offset primefilename
	call	getfilesize
	shl	eax,1		;use additional area
	ret


getfilesize:
	;inp dx = offset of file name
	;out eax = size

	mov	ax,3d00h		;read open
	int	21h

	push	ax			;handle
	mov	bx,ax
	mov	ax,4202h		;move file ptr to end
	xor	cx,cx
	xor	dx,dx
	int	21h
					;now dx:ax = file size
	pop	bx
	push	dx
	push	ax

	mov	ah,3eh			;close file
	int	21h

	pop	eax
	ret


primefilename	db	'PPMPPRMS.PPM',0
ansfilename	db	'PPMPANS1.PPM',0
DECOMPFILENAME	db	'PPMPDCMP.PPM',0


	align	4
BUFFER	dw	maxbufferwords dup(0)

CODE	ENDS
END	START
