;ppmpx.h ver3.6(for DPMI)

;	1991-99 by Yuji KIDA

HigherPower	equ	4096	
	;if p is larger than this then
		;higer powers are not checked.
		;used in mpqshd2p

ansDword	equ	10	;dword length of sieve answer

; next 2 prams are used in ppmpx2 and 2p
; B_LEN is optimal by 4 for 80 digit, by 5 for 105 digit
D_LEN	equ	3		;dword length of D
B_LEN	equ	6		;dword length of B

primeunitbytes	equ	16
maxprimes	equ	200000
;maxbufferbytes	equ	maxprimes/4
maxbufferwords	equ	maxprimes/8


mask16bit	equ	0000ffffh
mask24bit	equ	00ffffffh
deletedmark4B	equ	1

ROWSblock	equ	16			;ppmpx4b and ppmpx5a
ROWSblocklog	equ	4

;
; data area for each prime

_mainRAMoveradr	equ	9e000h	;0a0000h-9e000h >= size of display buffer
_mainRAMoverseg	equ	9e00h

;
; LPV constants
;
_QSORTCUTOFF	EQU	40

R1_BYTES	EQU	4
R2_BYTES	EQU	4
maxXbytes	EQU	80

COMBIMASK	EQU	80000000h
MAXCOMBI	EQU	20
COMBIUNITBYTES	EQU	MAXCOMBI*4

RAMUNITBYTES	EQU	12
RAMUNITDWORDS	EQU	3	;RAMUNITBYTES/4

;
; Gauss constants
;

matrixunitsize	equ	00020h	;matrix size is a multiple of 32
matrixunitmask	equ	0ffffe0h
MaxColumnWeight	equ	1d00h

;
; real-protect common parameter area
;

_memoseg	equ	_mainRAMoverseg-200h
_memoadr	equ	_memoseg*10h


_result		equ	0+_memoadr
_primes		equ	4+_memoadr
_primesR	equ	4
_primes4	equ	8h+_memoadr
_primes4R	equ	8
_primeadr	equ	0ch+_memoadr
_primeadrR	equ	0ch
_powersof2	equ	10h+_memoadr
_primepowers	equ	14h+_memoadr

		;18h ,1ch are not used

_inilog		equ	20h+_memoadr
_inilogR	equ	20h
_cutlog		equ	24h+_memoadr
_cutlogR	equ	24h
_offset		equ	28h+_memoadr
_sievewidth	equ	2ch+_memoadr
_sievewidthR	equ	2ch
_start		equ	30h+_memoadr
_absQ		equ	34h+_memoadr
_absQR		equ	34h

_sievetop	equ	40h+_memoadr
_sievetopR	equ	40h

_sieveBsize	equ	44h+_memoadr	;= sieveover - sievetop
_sieveBsizeR	equ	44h

_sieveConst	equ	48h+_memoadr	;= sieveBsize - sievetop
;_sieveConstR	equ	48h

_sieveover	equ	4ch+_memoadr
;_sieveoverR	equ	4ch

		;50h is not used

_sieveWsize	equ	54h+_memoadr	;= sieveBsize\2
_sieveWsizeR	equ	54h

		;58h is not used

_sortingtop	equ	60h+_memoadr

_D		equ	80h+_memoadr
_DR		equ	80h
_MIA2P		equ	0c0h+_memoadr

_bigpivot	equ	_D

_B		equ	0100h+_memoadr
_BR		equ	0100h

_W		equ	0140h+_memoadr	;also used by ISORT
;_WR		equ	0140h

		;200h-2ffh are gdttbl

_gdttblseg	equ	_memoseg+20h
_gdttbladr	equ	_gdttblseg*10h

;
; sieve answer area
;
sieveansarea	equ	_memoadr+300h

